--- modeline.el.orig	2002-03-13 03:52:07.000000000 -0500
+++ modeline.el	2007-06-19 13:58:09.000000000 -0400
@@ -827,10 +827,9 @@
 (defconst modeline-tty-frame-specifier (make-specifier 'boolean))
 (add-hook 'create-frame-hook 'modeline-update-tty-frame-specifier)
 (defun modeline-update-tty-frame-specifier (f)
-  (if-fboundp 'frame-tty-p
-      (if (and (frame-tty-p f)
-	       (> (frame-property f 'frame-number) 1))
-	  (set-specifier modeline-tty-frame-specifier t f))))
+  (if (and (eq (frame-type f) 'tty)
+	   (> (frame-property f 'frame-number) 1))
+      (set-specifier modeline-tty-frame-specifier t f)))
 
 (define-modeline-control tty-frame-id (list modeline-tty-frame-specifier
 					    " [%S]"
